/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap;

import com.bbn.openmap.Layer;
import fr.unicaen.openmap.layer.legendLayer.LegendLayer;

/**
 *
 * @author jchauvea
 */
public class LayerHandler extends com.bbn.openmap.LayerHandler {

    private boolean legended = false;

    @Override
    public void init(Layer[] layers) {
        for (Layer l : layers) {
            if (l instanceof LegendLayer) {
                legended = true;
            }
        }
        super.init(layers);
    }

    @Override
    public void addLayer(Layer layer, int position) {
        if(legended && position == 0)
            position = 1;
        super.addLayer(layer, position);
        if (layer instanceof LegendLayer) {
            legended = true;
        }
    }

    @Override
    public void removeLayer(Layer l) {
        super.removeLayer(l);
        if (l instanceof LegendLayer) {
            legended = false;
        }
    }

    @Override
    public void removeLayer(int position) {
        Layer l = allLayers[position];
        if (l instanceof LegendLayer) {
            legended = false;
        }
        super.removeLayer(position);

    }

    public boolean isLegended() {
        return legended;
    }
}
