// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors
 */
// </header>
package fr.unicaen.openmap.dataStorage;

import java.util.ArrayList;

/**
 *
 * @author jchauvea
 */
public class AnimationDSEventManager {

    public static ArrayList<AnimationDataStorageListener> listeners =
            new ArrayList<AnimationDataStorageListener>();

    public static void addAnimationDataStorageListener(AnimationDataStorageListener adsl) {
        if (!listeners.contains(adsl)) {
            listeners.add(adsl);
        }
    }

    public static void fireRemoveAnimation(MonoValuedFilterDataStorage ads) {
        for (AnimationDataStorageListener adsl : listeners) {
            adsl.animationRemoved(ads);
        }
    }

    public static void removeAnimationDataStorageListener(AnimationDataStorageListener adsl) {
        listeners.remove(adsl);
    }

    public static void fireAddAnimation(MonoValuedFilterDataStorage ads) {
        for (AnimationDataStorageListener adsl : listeners) {
            adsl.animationAdded(ads);
        }
    }

    public static void fireChangedAnimation(MonoValuedFilterDataStorage ads) {
        for (AnimationDataStorageListener adsl : listeners) {
            adsl.animationChanged(ads);
        }
    }

//    public static void fireChangedModeAnimation(AnimationDataStorage ads) {
//        for (AnimationDataStorageListener adsl : listeners) {
//            adsl.animationModeChanged(ads);
//        }
//    }
}
