// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage;

public class DataObjectComparatorFactory {

	
	public static DataObjectComparator buildComparator(String parameter, SortDataStorage.Format format){
		if(format == SortDataStorage.Format.NUMERIC){
			return new NumericDataObjectComparator(parameter, format);
		}
		if(format == SortDataStorage.Format.STRING)
            return new StringDataObjectComparator(parameter, format);

        return new DateDataObjectComparator(parameter, format);
		
		
	}
}
