// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/*
 * InformationDataStorage.java
 *
 * Created on 6 octobre 2005, 02:58
 *
 * This abstract class implements some method used by DataStorage and give the ability to Store informations in DataTable.
 *
 * All DataStorage which get informations from a DataSource MUST extends this class.
 */

package fr.unicaen.openmap.dataStorage;

import com.bbn.openmap.util.Debug;
import fr.unicaen.openmap.dataStorage.gui.DataTableModel;
import fr.unicaen.openmap.dataStorage.gui.DataTableStoragePanel;

/**
 *
 * @author christophe.turbout@info.unicaen.fr
 */
public abstract class InformationDataStorage extends DataStorage {
    
    protected DataTable dataTable = new DataTable();
    
    /** Creates a new instance of InformationDataStorage */
    public InformationDataStorage(DataStorageListener dsl) {
        super(dsl);
        Debug.message("DataStorage", this + " InformationDataStorage(DataStorageListener dsl)");
    }
  
    public DataObject getElementAt(int i) {
        return dataTable.getDataObjectAt(i);
    }
  
    public int getCount() {
        return dataTable.getRowCount();
    }

    /** This method asumes dtsp is a DataTableStoragePanel and resets its DataTableModel.
     * <p>Should be used in setProperties...
     */
    protected void resetDataTableStoragePanel(DataTableModel dataTableModel) {
	if (dtsp == null)
	    dtsp = new DataTableStoragePanel(dataTableModel);
	else{
	    ((DataTableStoragePanel)dtsp).setModel(dataTableModel);
        }
    }
}
