// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.expr;

import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class TestExprGrammar {
    private static void usage() { 
	System.err.println("Usage: java fr.unicaen.openmap.dataStorage.expr.TestExprGrammar [ [-n number] | input ]");
	System.exit(1);
    }
    private static String[] test = {
	"1",
	"1 +2",
	"log(1)*2",
    };
    public static void main(String[] args) throws Exception {
        ExprGrammarLexer lex;
	String input =  test[0];
	switch (args.length) {
	    case 2:
	    if (args[0].equals("-n")) 
		input = test[Integer.parseInt(args[1])];
	    else
		usage();
	    break;
	case 0:
	    input = test[0];
	    break;
	case 1:
	    input = args[0];
	    break;
	default:
	    usage();
	}

	lex = new ExprGrammarLexer(new ANTLRStringStream(input));
        CommonTokenStream tokens = new CommonTokenStream(lex);
        ExprGrammarParser parser = new ExprGrammarParser(tokens);
	// L'AST est construit
        CommonTree t  = (CommonTree) parser.arg().getTree();
	//System.out.println(t.toStringTree());
	/* 
	   CommonTreeNodeStream nodes = new CommonTreeNodeStream(t);
	   ExprASTEval evaluator = new ExprASTEval(nodes);
	   // évaluer à partir de l'axiome
	   evaluator.expr(); 
	*/
    }
}
