// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.gml.out;

import java.io.Writer;

import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;

import com.bbn.openmap.geo.Geo;
import com.bbn.openmap.omGraphics.OMPoly;

public class GMLPoly {

	private OMPoly omp;
	
	public GMLPoly(OMPoly omp){
		this.omp = omp;
	}
	
	public String toString(){

		double[] coords = omp.getLatLonArray();
		StringBuffer ch = new StringBuffer();
		for (int i = 0; i < coords.length; i = i + 2) {
			ch.append(Geo.degrees(coords[i + 1]) + "," + Geo.degrees(coords[i])
					+ " ");
		}
		return ch.toString();
	}
}
