// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.gui;

import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;


import com.bbn.openmap.Environment;
import com.bbn.openmap.I18n;

import fr.unicaen.openmap.dataStorage.AnimationDSEventManager;
import fr.unicaen.openmap.dataStorage.MonoValuedFilterDataStorage;
import fr.unicaen.openmap.dataStorage.MonoValuedFilterDataStorage.Mode;
import fr.unicaen.openmap.gui.ThemaMapFileChooserManager;
import fr.unicaen.openmap.util.HtmlGenerator;
import fr.unicaen.openmap.util.ImageExporter;
import fr.unicaen.openmap.util.gui.ComponentSizer;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.ButtonGroup;
import javax.swing.JFileChooser;
import javax.swing.JRadioButton;
import javax.swing.JTextField;


/**
 * AnimationDataStorage GUI 
 * @author jchauvea
 *
 */
public class MonoValuedFilterDataStoragePanel extends JPanel {

    protected I18n i18n = Environment.getI18n();
    //protected JButton bToolNext;
    protected JComboBox toolValueCombo, boxMode;
    protected JLabel toolValue;
    protected String exportDirectory = ".";
    private boolean exporting;
    protected JTextField fieldFile;
    protected JButton bExport;
    protected JButton buttonHTMLFile;
    protected JComboBox comboImageType;
    //protected JTabbedPane tabs;

    public MonoValuedFilterDataStoragePanel(final MonoValuedFilterDataStorage animDS) {
        super();
        Box content = Box.createVerticalBox();
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        ButtonGroup radioGroup = new ButtonGroup();
        final JRadioButton radioAnimLive = new JRadioButton("Live animation");
        final JRadioButton radioExport = new JRadioButton("Export animation");
        radioGroup.add(radioAnimLive);
        radioGroup.add(radioExport);
        JPanel panelRadio = new JPanel();
        panelRadio.add(radioAnimLive);
        panelRadio.add(radioExport);
        //setLayout(new BorderLayout());
        final JPanel panFilter = new JPanel();
        final Box exportPanel = Box.createVerticalBox();
        JPanel exportFilePanel = new JPanel();
        panFilter.setLayout(new BoxLayout(panFilter, BoxLayout.Y_AXIS));
        /*mode panel*/
        JPanel panMode = new JPanel();
        JLabel labMod = new JLabel(i18n.get(this, "mode", "Mode "));
        boxMode = new JComboBox(Mode.values());
        boxMode.setEnabled(false);
        //boxMode.setSelectedItem(animDS.getSelectedMode());
        boxMode.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                //animDS.setSelectedMode((Mode) ((JComboBox) e.getSource()).getSelectedItem());
                animDS.initFilterExpressionPanel();
                //AnimationDSEventManager.fireChangedModeAnimation(animDS);
                if (animDS.getFilterColumnName() != null && !animDS.getFilterColumnName().equals("")) {
                    AnimationDSEventManager.fireChangedAnimation(animDS);
                }
                panFilter.setVisible(false);
                panFilter.setVisible(true);
                //filterExpressionPanel.setVisible(false);
                //filterExpressionPanel.setVisible(true);
            }
        });
        panMode.add(labMod);
        panMode.add(boxMode);
        /*buttons panel*/
//        JPanel panOkCancel = new JPanel();
//        bOk = new JButton(i18n.get(AnimationDataStorage.class, "apply", "Apply"));
//        bDelete = new JButton(i18n.get(AnimationDataStorage.class, "remove", "Remove"));
//        panOkCancel.add(bOk);
//        panOkCancel.add(bDelete);

        final JLabel labTitle = new JLabel(
                " - " + i18n.get(MonoValuedFilterDataStorage.class, "name", "Animation adaptor") + " - ");
        //labTitle.setHorizontalAlignment(JLabel.LEFT);
        Font f = labTitle.getFont();
        labTitle.setFont(f.deriveFont(f.getStyle() ^ Font.BOLD));
        JPanel panLabTitle = new JPanel();
        panLabTitle.add(labTitle);
        panFilter.add(panLabTitle);
        panFilter.add(animDS.getFilterExpressionPanel());
        final Box livePanel = Box.createVerticalBox();
        livePanel.add(panMode);
        //main.add(animDS.getSortPanel());

        //main.add(new JPanel());
//        livePanel.add(panOkCancel);

        //panWrap.add(main);
        //add(panWrap);
//
//        ActionListener deleteListener = new ActionListener() {
//
//            public void actionPerformed(ActionEvent arg0) {
//                AnimationDataStoragePanel.this.setVisible(false);
//                int rep = JOptionPane.showConfirmDialog(labTitle,
//                        i18n.get(AdaptorButtonArray.class,
//                        "removeAnimationConfirmation",
//                        I18n.TOOLTIP,
//                        "Do you really want to remove the Animator?"),
//                        i18n.get(this, "removeAdaptorConfirmation",
//                        "Confirmation"),
//                        JOptionPane.YES_NO_OPTION);
//                if (rep == JOptionPane.YES_OPTION) {
//                    animDS.fireRemoveAnimation();
//                }
//            }
//        };
//
//        bDelete.addActionListener(deleteListener);
//
//        bOk.addActionListener(new ActionListener() {
//
//            public void actionPerformed(ActionEvent arg0) {
//                AnimationDataStoragePanel.this.setVisible(false);
//            }
//        });

        //tabs = new JTabbedPane();
        //tabs.addTab("Animation", panWrap);
        JPanel pExport = new JPanel();
        bExport = new JButton("export");
        //panWrap.add(pExport);
        final JTextField path = new JTextField();
        ComponentSizer.fixComponentSize(path, new Dimension(200,20));
        JButton bChooser = new JButton("...");
        ComponentSizer.fixComponentSize(bChooser, new Dimension(25,25));
        bChooser.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                exportDirectory = ThemaMapFileChooserManager.imageSaveDialog("", 1024, 768, "",JFileChooser.DIRECTORIES_ONLY) + System.getProperty("path.separator");
                path.setText(exportDirectory);
            }
        });
        //tabs.addTab("Export", pExport);
        bExport.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                if(!exporting){
                    exporting = true;
                    animDS.export(exportDirectory, ImageExporter.ImageType.valueOf(comboImageType.getSelectedItem().toString()));
                    bExport.setText("stop");
                }
                else{
                    animDS.stopExport();
                    buttonHTMLFile.setEnabled(true);
                }
            }
        });
        comboImageType = new JComboBox(ImageExporter.ImageType.values());
        pExport.add(comboImageType);
        pExport.add(path);
        pExport.add(bChooser);
        pExport.add(bExport);
        exportFilePanel.add(pExport);

        content.add(panelRadio);//, BorderLayout.NORTH);
        content.add(panFilter);// BorderLayout.CENTER);
        content.add(livePanel);//, BorderLayout.SOUTH);
        radioAnimLive.setSelected(true);
        ActionListener chListener = new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                if(radioAnimLive.isSelected()){
                    animDS.setExportMode(false);
                    MonoValuedFilterDataStoragePanel.this.remove(exportPanel);
                    MonoValuedFilterDataStoragePanel.this.add(livePanel, BorderLayout.SOUTH);
                    livePanel.updateUI();

                }
                else{
                    animDS.setExportMode(true);
                    MonoValuedFilterDataStoragePanel.this.remove(livePanel);
                    MonoValuedFilterDataStoragePanel.this.add(exportPanel, BorderLayout.SOUTH);
                    exportPanel.updateUI();
                }
                MonoValuedFilterDataStoragePanel.this.updateUI();
            }

        };

        radioAnimLive.addActionListener(chListener);
        radioExport.addActionListener(chListener);

        JPanel panExportOptions = new JPanel();
        buttonHTMLFile = new JButton("Generate HTML file");
        fieldFile = new JTextField("Animation.html");
        JPanel panFile = new JPanel();
        //panFile.add(comboImageType);
        panFile.add(buttonHTMLFile);
        panFile.add(new JLabel(i18n.get(this, "fileName", "File name")));
        panFile.add(fieldFile);
        panExportOptions.add(panFile);
        exportPanel.add(exportFilePanel);
        exportPanel.add(panExportOptions);
        JPanel pBottom = new JPanel();
//        JButton bClose = new JButton(i18n.get(this,"close","close"));
//        bClose.addActionListener(deleteListener);
//        pBottom.add(bClose);
        exportPanel.add(pBottom);
        buttonHTMLFile.setEnabled(false);
        buttonHTMLFile.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                //System.out.println("-----------------------"+ImageExporter.ImageType.valueOf(comboImageType.getSelectedItem().toString()));
                 HtmlGenerator.generateHTML(exportDirectory,fieldFile.getText(),ImageExporter.ImageType.valueOf(comboImageType.getSelectedItem().toString()));
            }
        });
        add(content);
        content.setBorder(BorderFactory.createTitledBorder(""));
        add(Box.createRigidArea(new Dimension(content.getWidth(), 10)));//bottom margin with ds gui
        add(animDS.getDataStorage().getGUI());
    }

    public void filterSelected() {
        boxMode.setEnabled(true);
    }

    public void setSelectedMode(MonoValuedFilterDataStorage.Mode mode){
        boxMode.setSelectedItem(mode);
    }


}
