package fr.unicaen.openmap.gui;

import com.bbn.openmap.Layer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.awt.Color;
import java.awt.Component;
import java.util.EventObject;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellEditor;

public class LayerCellEditor extends DefaultTreeCellEditor {

    //private Component component;

    public LayerCellEditor(JTree tree, LayerCellRenderer renderer) {
        super(tree, renderer);
    }

    @Override
    public Component getTreeCellEditorComponent(JTree tree, Object value, boolean isSelected, boolean expanded, boolean leaf, int row) {

        JComponent component;
        Object obj = ((DefaultMutableTreeNode) value).getUserObject();
        if (obj instanceof Thematic) {
            component = new ThematicTreeNodeComponent((LayersTree) tree,
                    (Thematic) obj);
        } else {
            if (obj instanceof Layer) {
                if (tree instanceof AtlasLayersTree) {
                    component = new AtlasLayerTreeNodeComponent((AtlasLayersTree) tree,
                            (Layer) obj, (DefaultMutableTreeNode) value);
                } else {
                    component = new LayerTreeNodeComponent((LayersTree) tree,
                            (Layer) obj);
                }
            }
            else
                {
                component = new JPanel();
                component.add(new JLabel(value.toString()));
                component.setBackground(Color.WHITE);
                /*super.getTreeCellEditorComponent(tree,
                        value,
                        isSelected,
                        expanded,
                        leaf,
                        row);*/
            }
        }
        editingContainer = component;
        component.setBackground(Color.LIGHT_GRAY);
        //editingContainer.add(getOnOffButton(),0);
        return component;


    }

    @Override
    public boolean canEditImmediately(EventObject event) {
        return true;
    }
}
