package fr.unicaen.openmap.gui;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.bbn.openmap.Layer;

import com.bbn.openmap.LayerHandler;
import fr.unicaen.openmap.AtlasLayerHandler;
import fr.unicaen.openmap.util.Util;
import java.awt.event.ItemListener;
import javax.swing.JCheckBox;
import javax.swing.JToggleButton;
import javax.swing.tree.DefaultMutableTreeNode;

public class LayerTreeNodeComponent extends ThemaMapTreeNodeComponent {

    protected Layer layer;

    public LayerTreeNodeComponent(LayersTree tree, Layer layer) {
        this.layer = layer;
        this.tree = tree;
        setBackground(Color.WHITE);
        add(getOnOffButton());
        lab = new JLabel(layer.getName());
        add(lab);
        updateUI();
    }

    protected JToggleButton getOnOffButton() {
        JCheckBox b = new JCheckBox(
                layer.isVisible() ? Util.loadIcon("enabled.png") : Util.loadIcon("disabled.png"), layer.isVisible());
        b.setBorder(/*BorderFactory.createEmptyBorder(0,0,0,10)*/null);
        b.setBorderPainted(false);
        b.setFocusPainted(false);
        b.setBackground(Color.WHITE);
        b.setOpaque(false);
        b.setFocusable(true);
        b.addItemListener(new ItemListener() {

            public void itemStateChanged(ItemEvent e) {
                if (LayerTreeNodeComponent.this.getBackground() != Color.LIGHT_GRAY) {
                    LayerTreeNodeComponent.this.setBackground(Color.LIGHT_GRAY);
                }
                JCheckBox bsource = (JCheckBox) e.getSource();
                //LayerHandler lh = tree.getLayerHandler();
                if (e.getStateChange() == ItemEvent.SELECTED) {
                    bsource.setIcon(Util.loadIcon("enabled.png"));
                    tree.getLayerHandler().turnLayerOn(true, layer);
                } else {
                    bsource.setIcon(Util.loadIcon("disabled.png"));
                    tree.getLayerHandler().turnLayerOn(false, layer);
                }
            }
        });
        return b;
    }
}
