// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import java.awt.Container;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

import com.bbn.openmap.Layer;
import com.bbn.openmap.MapBean;

public class StatusLightPanel extends com.bbn.openmap.gui.StatusLightPanel{
	
	//protected ThemaMapPanelsManager panelsManager;
	
    @Override
    @SuppressWarnings("unchecked")
    protected JButton getStatusLightForLayer(Layer layer) {

        if (layer == null) {
            return null;
        }
        final Layer l = layer;
        JButton newLight = (JButton) statusLights.get(layer);

        if (newLight == null) {
            //          newLight = new JButton(greyIcon);
            newLight = new JButton(greenIcon);
            newLight.setToolTipText(layer.getName());
            newLight.setMargin(new Insets(2, 1, 2, 1));
            statusLights.put(layer, newLight);

            if (lightTriggers) {
                //newLight.setActionCommand(Layer.DisplayPaletteCmd);
                newLight.addActionListener(new ActionListener(){
                	public void actionPerformed(ActionEvent ev){
                		Container parent = l.getGUI().getParent();
                		l.showPalette();
                		//panelsManager.getLayersPanel().getLayerPane(l).setPaletteShown(true);
                		if(parent!=null && parent instanceof JPanel)
                			((JPanel)parent).updateUI();
                		//System.out.println(l.getGUI().getParent().getClass());
                	}
                });
                //newLight.setBorderPainted(true);
            } else {
                //newLight.setBorderPainted(false);
            }
        }
        return newLight;
    }

    public void findAndInit(Object someObj) {
        if (someObj instanceof MapBean) {
            setMap((MapBean) someObj);
        }
        //if(someObj instanceof ThemaMapPanelsManager)
        //	panelsManager = (ThemaMapPanelsManager)someObj;
    }

}
