// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.dnd;

import java.awt.Color;
import java.awt.event.MouseEvent;

import javax.swing.JTabbedPane;

public class DragTabArea extends DragArea{

	private JTabbedPane tabbed;
	//private int index;

	public DragTabArea(String title, MovableBox box, DndTransferHandler handler, MovableBoxesContainer boxesContainer){
		super(title, box, handler, boxesContainer);
	}
	public DragTabArea(String title, MovableBox box, DndTransferHandler handler, MovableBoxesContainer boxesContainer,
			JTabbedPane tabbed) {
		this(title, box, handler, boxesContainer);
		this.tabbed = tabbed;

	}
	
	public void mouseClicked(MouseEvent e) {

		tabbed.setSelectedIndex(getTabbedIndex());
		
	}

	public int getTabbedIndex(){
		int position = 0;
		for(int i = 0; i < tabbed.getTabCount(); i++){
			if(tabbed.getTabComponentAt(i) == this){
				position = i;
				break;
			}	
		}
		return position;
	}
	
	public JTabbedPane getTabbed() {
		return tabbed;
	}
	public void setTabbed(JTabbedPane tabbed) {
		this.tabbed = tabbed;
	}

}
