
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import com.bbn.openmap.omGraphics.OMText;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.OffsetableRaw;
import java.awt.Font;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.Rectangle;
import java.awt.geom.Point2D;

/**
 *
 * @author jchauvea
 */
public class OMLabel extends OMOffsetable {

    private OMText omText;

    public OMLabel(OffsetableRaw offRaw, String id, float lat, float lon, int offX, int offY, String name, Font font, int align, boolean v, boolean l) {
        super(offRaw, id, lat, lon, offX, offY, v, l);
        omText = new OMText(lat, lon, offX, offY, name, font, align);
        add(omText);
        drawJoiningLine();
    }

    public OMLabel(OffsetableRaw offRaw,String id, float lat, float lon, int offX, int offY, String name, Font font, int align, boolean v) {
        super(offRaw, id, lat, lon, offX, offY, v, false);
        omText = new OMText(lat, lon, offX, offY, name, font, align);
        add(omText);
        drawJoiningLine();
    }

    public OMText getOMText(){return omText;}

    @Override
    public void computeAnchors() {

        /*Polygon p =omText.getPolyBounds();
        Rectangle r = p.getBounds();*/
        //int width = 25;//(int) r.getWidth();
        //int height = 10;//(int) r.getHeight();

        Point2D bottom = new Point(0, 0);
        /*Point2D top = new Point(0, height);
        Point2D left = new Point(width / -2, height / 2);
        Point2D right = new Point(width / 2, height / 2);*/

        anchors = new Anchors(bottom, bottom, bottom, bottom);
    }

//    public void setLocation(int x, int y){
//        //System.out.println("OMLABEL SET LOCATION "+x+";"+y);
//        omText.setX(x);
//        omText.setY(y);
//    }

    @Override
    public void translate(int x, int y){
        super.translate(x, y);
        omText.setX(getX());
        omText.setY(getY());
    }

//    @Override
//    public int getX() {
//        return omText.getX();
//    }
//
//    @Override
//    public int getY() {
//        return omText.getY();
//    }

}
