/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import com.bbn.openmap.omGraphics.OMGraphic;
import com.bbn.openmap.omGraphics.OMGraphicList;
import com.bbn.openmap.proj.coords.LatLonPoint;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.OffsetableRaw;
import java.awt.Point;
import java.awt.geom.Point2D;

/**
 *
 * @author jchauvea
 */
public class OMMultiRegularPolygon extends OMOffsetable {

    private int width;
    private OMGraphicList polygons;

    public OMMultiRegularPolygon(OffsetableRaw offRaw, String id, int nb, float lat, float lon,
            int nbEdges, float radius, int offX, int offY,
            float startAngle, int starCoef, int gapPercentage, boolean cpVisibility, boolean l) {
        super(offRaw, id, lat, lon, offX, offY, cpVisibility, l);
        int gap = (int) (radius * gapPercentage / 100.0);
        int polyWidth = (int) (2 * radius + gap); // place needed for one poly
        width = polyWidth * nb;
        polygons = new OMGraphicList();
        // nbSqrt is the edge of the biggest possible full square
        int nbSqrt = (int) Math.sqrt(nb);

        // try to center the group of polygones
        offX -= polyWidth * nbSqrt / 2;
        offY -= polyWidth * nbSqrt / 2;

        // draw a square of regular polygones
        for (int x = 0; x < nbSqrt; x++) {
            for (int y = 0; y < nbSqrt; y++) {
                polygons.add(new OMRegularPolygon(offsetableRaw, "", lat, lon, nbEdges, radius,
                        offX + x * polyWidth,
                        offY + y * polyWidth,
                        startAngle, starCoef, false, l));
            }
        }
        nb -= nbSqrt * nbSqrt;
        // we still have nb polys to draw

        // we start by the rigth most vertical line
        for (int y = 0; nb > 0 && y < nbSqrt; nb--, y++) {
            polygons.add(new OMRegularPolygon(offsetableRaw, "", lat, lon, nbEdges, radius,
                    offX + nbSqrt * polyWidth,
                    offY + y * polyWidth,
                    startAngle, starCoef, false, l));
        }
        // we end by the bottom horizontal line
        for (int x = 0; nb > 0 && x < nbSqrt; nb--, x++) {
            polygons.add(new OMRegularPolygon(offsetableRaw,"", lat, lon, nbEdges, radius,
                    offX + x * polyWidth,
                    offY + nbSqrt * polyWidth,
                    startAngle, starCoef, false, l));

        }

        ///LatLonPoint latLonPoint = new LatLonPoint.Float(lat, lon);
        //controlPoints.add(new OMOffsetableControlPoint(latLonPoint, this, offX, offY));
        add(polygons);
        drawJoiningLine();

    }

    @Override
    public void computeAnchors() {

        Point2D bottom = new Point(0, width / -2 - MARGIN);
        Point2D top = new Point(0, width / 2 + MARGIN);
        Point2D left = new Point(width / -2 - MARGIN, 0);
        Point2D right = new Point(width / 2 + MARGIN, 0);

        anchors = new Anchors(top, left, bottom, right);
    }

    @Override
    public void translate(int x, int y) {
        super.translate(x, y);
          for(OMGraphic om : polygons){
            OMRegularPolygon p = (OMRegularPolygon)om;
            p.translate(x, y);
        }
    }

}
