// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import java.awt.Image;

import javax.swing.ImageIcon;

import com.bbn.openmap.omGraphics.OMRaster;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.OffsetableRaw;

public class OMPictogram extends /*OMRaster*/OMOffsetable implements Comparable<OMPictogram>, HaveWidthAndData {

        OMRaster pictogram;

	public int compareTo(OMPictogram o) {
	    //	    getImage().getWidth(null) 
		return 0;
	}

        public OMPictogram(OffsetableRaw offRaw, String id, float lat, float lon, int offx, int offy,  ImageIcon im, boolean cp, boolean l){
                super(offRaw, id, lat, lon, offx, offy, cp, l);
		pictogram = new OMRaster(lat,lon,offx, offy,im);
                add(pictogram);
                //System.out.println(controlPoint);
	}

	public OMPictogram(OffsetableRaw offRaw, String id, float lat, float lon, int offx, int offy,  ImageIcon im){
                super(offRaw, id, lat, lon, offx, offy, false, false);
		pictogram = new OMRaster(lat,lon,offx, offy,im);
                add(pictogram);
	}
	/**
	 * Scale the ImageIcon
	 * @param im
	 * @param width
	 * @return
	 */
	public static ImageIcon scaleImageIcon(ImageIcon im, int width){
		/*if(width<1)
			width=1;*/
		Image scaled = im.getImage().
			getScaledInstance(width, -1, Image.SCALE_FAST);
		im.setImage(scaled);
		return im;
	}
	
	public String getData() {
		// TODO Auto-generated method stub
		return null;
	}

    @Override
    public void computeAnchors() {
        //throw new UnsupportedOperationException("Not supported yet.");
    }

    public int getWidth() {
        return pictogram.getWidth();
    }


    @Override
    public void translate(int x, int y) {
        super.translate(x, y);
        pictogram.setX(getX());
        pictogram.setY(getY());
    }

}
