// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.util;
import java.util.*;
import java.util.regex.*;

import fr.unicaen.openmap.dataStorage.*;
import fr.unicaen.openmap.util.*;


public class DataSumColumnsValueComputer extends DataValueComputer {
    private String[] dataColumnNames;
    public DataSumColumnsValueComputer(String[] dataColumnNames) { 
	this.dataColumnNames = dataColumnNames; 
    }
    public double getValue(DataObject data) { 
	double sum = 0.0;
	for (int i = 0; i < dataColumnNames.length; i++) {
	    sum += Util.parseDouble(data.getData(dataColumnNames[i]));
	}
	return sum;
    }
    public double getValue(double v) { 
	return v;
    }
    public double[] getValues(DataObject data) { 
	double sum = 0.0;
	double[] values = new double[dataColumnNames.length+1];
	Object data_i;
	for (int i = 0; i < dataColumnNames.length; i++) {
	    data_i = data.getData(dataColumnNames[i]);
	    if (data_i == null || "".equals(data_i.toString()))
		return null;
	    values[i] = Util.parseDouble(data_i);
	    sum += values[i];
	}
	values[dataColumnNames.length] = sum;
	return values;
    }
    public String getString(DataObject data) {
	// very expensive code
	double[] values = getValues(data);
	return String.valueOf(values[values.length-1]);
    }
}
