// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/*
 * AboutMenuItemBuildVersio.java
 *
 * Created on 26 janvier 2007, 11:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package fr.unicaen.openmap.util;

import com.bbn.openmap.Environment;
import com.bbn.openmap.gui.menu.AboutMenuItem;
import java.net.URL;
import java.util.Properties;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * AboutMenuItemBuildVersion.java extracts copyright et version info from
 * the file fr/unicaen/openmap/app/compile.version.properties.
 *
 * @author christof
 */
public class AboutMenuItemBuildVersion extends AboutMenuItem {
    
    private Properties props;
    
    /** Creates a new instance of AboutMenuItem */
    public AboutMenuItemBuildVersion() {
	props = new Properties();
        try {
            URL url = ClassLoader.getSystemResource("fr/unicaen/openmap/app/compile.version.properties");
            props.load(url.openStream());
	} catch(Exception e){ }
    }
    
    public String getRevision(){
	return props.getProperty("log.logentry(revision)");
    }    

    public String getCopyrightMessage() {
	String endl = Environment.get("line.separator");
	return endl + endl
	    + props.getProperty("project.name") + " " + props.getProperty("project.version")
	    + " (" + getRevision() + "  " + props.getProperty("date.time") + ")"
	    + endl
	    + " http://themamap.info.unicaen.fr"
	    + endl + endl;
    }
    
    protected JComponent createCopyrightViewer() {
        JScrollPane scroller =(JScrollPane) super.createCopyrightViewer();
        JTextArea textArea = (JTextArea)scroller.getViewport().getView();
        textArea.append(getCopyrightMessage());
        return scroller;
    }
}
