/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.unicaen.openmap.util;

import fr.unicaen.openmap.dataStorage.SortDataStorage;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import fr.unicaen.openmap.util.Util;
/**
 *
 * @author dje
 */
public class ValueComparator {

    public static void sortValues(List<String> values, SortDataStorage.Format format) {
        if (format == SortDataStorage.Format.NUMERIC) {
            sortNumericValues(values);
            return;
        }
        if (format == SortDataStorage.Format.STRING) {
            sortStringValues(values);
            return;
        }
        sortDateValues(values, format);
    }

    public static void sortNumericValues(List<String> values) {
        Logger.getLogger("ValueComparator").log(Level.INFO,"SORT NUMERIC VALUES");
        Collections.sort(values, new Comparator<String>() {

            public int compare(String o1, String o2) {
                double d1 = Util.parseDouble(o1);
                double d2 = Util.parseDouble(o2);
		if (d1 < d2) 
		    return -1;
		if (d1 > d2)
		    return 1;
                return 0;
            }
        });
    }

    public static void sortStringValues(List<String> values) {
         Logger.getLogger("ValueComparator").log(Level.INFO,"SORT STRING VALUES");
	 Collections.sort(values);
    }

    public static void sortDateValues(List<String> values, SortDataStorage.Format format) {
         Logger.getLogger("ValueComparator").log(Level.INFO,"SORT DATE VALUES");
        final SimpleDateFormat dateFormat = new SimpleDateFormat(format.getInnerFormat());
        Collections.sort(values, new Comparator<String>() {

            public int compare(String o1, String o2) {
                try {
                    Date date1 = dateFormat.parse(o1);
                    Date date2 = dateFormat.parse(o2);
                    Long time1 = date1.getTime();
                    Long time2 = date2.getTime();
                    //Logger.getLogger("ValueComparator").log(Level.INFO, o1 + " compare to " + o2 + " = " + time1.compareTo(time2));
                    return time1.compareTo(time2);
                } catch (ParseException ex) {
                    //Logger.getLogger(ValueComparator.class.getName()).log(Level.SEVERE, null, ex);
                }
                return 0;
            }
        });
    }
}
