// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.omgraphics;

import com.bbn.openmap.omGraphics.*;
import com.bbn.openmap.proj.coords.LatLonPoint;
import com.bbn.openmap.util.*;
import com.bbn.openmap.*;

public class OMControlPoint extends OMPoly {
	
    private static double[] mkPts(double lat, double lon, float radius) {
	double[] pts = { 
	    lat-radius, lon+radius,
	    lat+radius, lon+radius,
	    lat+radius, lon-radius,
	    lat-radius, lon-radius,
	    lat-radius, lon+radius
	};
	return pts;
    }

    public OMControlPoint(double lat, double lon, float radius) {
	
	super(mkPts(lat, lon, radius), 
	      OMGraphic.DECIMAL_DEGREES, OMGraphic.LINETYPE_STRAIGHT);
	this.lat = lat;
	this.lon = lon;
	setAppObject(new LatLonPoint.Double(lat, lon));
    }	


    public LatLonPoint getLatLon() {
	return (LatLonPoint)getAppObject();
    }

}
